            #GIT_CMT=30a9c98d98985d13230bf7e3662226896d5157e3
%define pname oracle-database-preinstall
%define dbrel 19c
%define configdir /etc/sysconfig
%define logdir /var/log
%define version 1.0
%define release 2%{?dist}
%define name %{pname}-%{dbrel}
%global debug_package %{nil}

Summary: "Sets the system for Oracle Database single instance and Real Application Cluster %{dbrel} install for Oracle Linux %{?dist}"
Name: %{name}
Version: %{version}
Release:    2.el7
Group: Test Environment/Libraries
License: GPLv2
Vendor: Oracle
Source: oracle-database-preinstall-1.0.tar.bz2
Provides: %{name} = %{version}

Conflicts: exadata-base
Requires(pre): /etc/redhat-release 
Requires: procps module-init-tools ethtool initscripts bind-utils nfs-utils util-linux-ng pam 
Requires: xorg-x11-utils xorg-x11-xauth smartmontools 
Requires: binutils glibc glibc-devel 
Requires: ksh libaio libaio-devel libgcc libstdc++ libstdc++-devel 
Requires: make sysstat openssh-clients 
Requires: psmisc net-tools unzip bc tar 
%if 0%{?el7} 
Requires: compat-libcap1 
%endif 
%if 0%{?el8} 
Requires: libnsl compat-openssl10 
%endif  

BuildRequires: bash
BuildRoot: %{_builddir}/%{pname}-%{version}-root

%description
"The Oracle Preinstallation RPM package installs software packages and sets system parameters required for Oracle Database single instance and Oracle Real Application Clusters %{dbrel} installations for Oracle Linux %{?dist}"
Files affected: /etc/sysctl.conf, /boot/grub/menu.lst OR /boot/grub2/grub.cfg OR /boot/efi/EFI/redhat/grub.cfg
Files added: /etc/security/limits.d/%{name}.conf

%prep
%setup -q -n %{pname}-%{version}

%build

%install 
mkdir -p -m 755 $RPM_BUILD_ROOT/usr/bin
mkdir -p -m 755 $RPM_BUILD_ROOT/etc/rc.d/init.d
mkdir -p -m 755 $RPM_BUILD_ROOT/etc/security/limits.d
mkdir -p -m 755 $RPM_BUILD_ROOT/%{configdir}/%{name}
mkdir -p -m 700 $RPM_BUILD_ROOT/%{logdir}/%{name}/results
install -m 700 %{pname}-verify $RPM_BUILD_ROOT/%{configdir}/%{name}/%{name}-verify
install -m 700 %{pname}-verify $RPM_BUILD_ROOT/usr/bin/%{name}-verify 
install -m 600 %{pname}.param $RPM_BUILD_ROOT/%{configdir}/%{name}/%{name}.param
install -m 700 %{pname}-firstboot $RPM_BUILD_ROOT/etc/rc.d/init.d/%{name}-firstboot
touch $RPM_BUILD_ROOT/etc/security/limits.d/%{name}.conf
ln -f -s %{configdir}/%{name}/%{name}-verify $RPM_BUILD_ROOT/usr/bin/%{name}-verify 
sed -i s/%{pname}/%{name}/g $RPM_BUILD_ROOT/etc/rc.d/init.d/%{name}-firstboot
sed -i s/%{pname}/%{name}/g $RPM_BUILD_ROOT/%{configdir}/%{name}/%{name}.param

%clean 
rm -rf $RPM_BUILD_ROOT

%define prescript()  \
if [ -f %{configdir}/%{pname}-%1/%{pname}-%1.param ]; then  \
  cp -f %{configdir}/%{pname}-%1/%{pname}-%1.param %{logdir}/%{pname}-%1/results/.%{pname}-%1.param; \
fi; \
if [ -d %{configdir}/%{pname}-%1 ]; then \
  rm -rf %{configdir}/%{pname}-%1; \
fi;

%define preunscript()  \
if [ "$1" = "0" ] ; then \
 chkconfig --del %{pname}-%1-firstboot; \
 if [ -x /usr/bin/%{pname}-%1-verify ]; then \
   /usr/bin/%{pname}-%1-verify -u 2> /dev/null 1>&2; \
 fi; \
fi;

%define posttransscript()  \
/usr/bin/%{pname}-%1-verify 2>/dev/null 1>&2; \
if ! [ -f %{configdir}/%{pname}-%1/%{pname}-%1.conf ]; then \
       chkconfig --add %{pname}-%1-firstboot; \
fi;

%define postunscript()  \
if [ "$1" = "0" ] ; then \
 if [ -d %{configdir}/%{pname}-%1 ]; then \
   rm -rf %{configdir}/%{pname}-%1; \
 fi; \
 if [ -d %{logdir}/%{pname}-%1 ]; then  \
   rm -rf %{logdir}/%{pname}-%1; \
 fi; \
fi;

%pre
%{expand:%%prescript %{dbrel}}

%preun
%{expand:%%preunscript %{dbrel}}

%posttrans
%{expand:%%posttransscript %{dbrel}}

%postun
%{expand:%%postunscript %{dbrel}}

%files
%defattr(-,root,root)
%config %{configdir}/%{name}/%{name}.param
%ghost /etc/security/limits.d/%{name}.conf
%{configdir}/%{name}
/etc/rc.d/init.d/%{name}-firstboot
%{configdir}/%{name}/%{name}-verify
%{logdir}/%{name}
/usr/bin/%{name}-verify

%changelog
* Wed Mar 11 2020 Tianyue Lan <tianyue.lan@oracle.com> - 1.0-2.el7
- correct specfile name

* Tue Mar 10 2020 Vasundhara V <vasundhara.venkatasubramanian@oracle.com> [1.0-2.el7]
 - Fix %pre script for dbrel 
 - Revert to chkconfig

* Mon Mar 9 2020 Vasundhara V <vasundhara.venkatasubramanian@oracle.com> [1.0-1.6.el7]
 - Remove compat-libstdc++ from dependencies [Orabug: 30958861]
 - Include ulimit -d [Orabug: 30407482]
 - Replaced chkconfig with systemctl in the spec
 - Removed check for el6 in the spec as it is not supported for 19c

* Tue Feb 11 2020 Vasundhara V <vasundhara.venkatasubramanian@oracle.com> [1.0-1.5.el7]
 - Do not install on an EXADATA system [Orabug: 30846947]

* Mon Jul 29 2019 Vasundhara V <vasundhara.venkatasubramanian@oracle.com> [1.0-1.4.el7]
 - Look for exact match in /etc/group [Orabug: 30106011]
 - Fix for picking the next available uid/gid [Orabug: 30108093]
 - Spec made modular 
 - Code moved to git

* Tue Dec 4 2018  Vasundhara V <vasundhara.venkatasubramanian@oracle.com> [1.0-1.el7]
 - Initial version
